/* 項目を無効にする */
function disableAndClearItem(elementId) {
  if ($('#' + elementId).is('select')) {
    $('#' + elementId).val('').prop('disabled', true).addClass('disableItem').removeClass('ErrorItem');
  } else {
    $('#' + elementId).val('').prop('readonly', true).addClass('disableItem').removeClass('ErrorItem');
  }

}
/* 項目を有効にする */
function enableItem(elementId) {
  if ($('#' + elementId).is('select')) {
    $('#' + elementId).prop('disabled', false).removeClass('disableItem');
  } else {
    $('#' + elementId).prop('readonly', false).removeClass('disableItem');
  }
}

/* 選択項目初期処理 */
function initSelectItem() {
  $('select option').css({ 'color': 'black', 'font-style': 'normal', 'background-color': 'white' });
  $('select').each(function () {
    /*すべての必須選択項目*/
    if ($(this).closest('td').find('div.required').length > 0) {
      // 画面初期表示時の処理
      $(this).find('option:first').attr({ label: '選択してください' });

      if ($(this).find('option:selected').text() === '選択') {
        $(this).css({ 'color': '#a09b9b', 'font-style': 'italic' });
      } else {
        $(this).find('option').filter(function () {
          return this.text == '選択';
        }).remove();
      }
      // onChangeイベント追加
      $(this).change(function () {
        if ($(this).find('option:selected').text() === '選択') {
          $(this).css({ 'color': '#a09b9b', 'font-style': 'italic' });
        } else {
          $(this).css({ 'color': 'black', 'font-style': 'normal' });
        }
      });
      // onClickイベント追加
      $(this).on('click', function () {
        $(this).find('option').filter(function () {
          return this.text == '選択';
        }).remove();
        $(this).css({ 'color': 'black', 'font-style': 'normal' });
      });
    }
    /*すべての非必須選択項目*/
    else {
      $(this).find('option:first').attr({ label: '' }).text('');
    }
  });
}

function initOneSelectItem(id) {
  $('#' + id).css({ 'color': 'black', 'font-style': 'normal', 'background-color': 'white' });
  $('#' + id).find('option:first').attr({ label: '' }).text('選択');
  if ($('#' + id).closest('td').find('div.required').length > 0) {
    // 画面初期表示時の処理
    $('#' + id).find('option:first').attr({ label: '選択してください' });

    if ($('#' + id).find('option:selected').text() === '選択') {
      $('#' + id).css({ 'color': '#a09b9b', 'font-style': 'italic' });
    } else {
      $('#' + id).find('option').filter(function () {
        return this.text == '選択';
      }).remove();
    }
    // onChangeイベント追加
    $('#' + id).change(function () {
      if ($('#' + id).find('option:selected').text() === '選択') {
        $('#' + id).css({ 'color': '#a09b9b', 'font-style': 'italic' });
      } else {
        $('#' + id).css({ 'color': 'black', 'font-style': 'normal' });
      }
    });
    // onClickイベント追加
    $('#' + id).on('click', function () {
      $('#' + id).find('option').filter(function () {
        return this.text == '選択';
      }).remove();
      $('#' + id).css({ 'color': 'black', 'font-style': 'normal' });
    });
  }
  /*すべての非必須選択項目*/
  else {
    $('#' + id).find('option:first').attr({ label: '' }).text('');
  }

}

/* Window サイズが変わった時、コメントの位置再計算 */
function resizeInputComments(targetId, commentsId, commentColNum, totalColNum) {
  let targetElement = $("#" + targetId);
  let targetElement_tr = targetElement.parents('tr');

  let paddingRight = parseInt(targetElement.closest('td').css("padding-right"));
  $('#' + commentsId).css({
    'left': targetElement.position().left,
    'width': targetElement_tr.width() * commentColNum / totalColNum - targetElement.position().left * 2 - paddingRight
  });
}

/* 項目の下にコメント追加 */
function insertCommentsUnderInput(targetId, commentsId, commentColNum, totalColNum, comments, isMultiComments = false) {

  let targetElement = $("#" + targetId);
  //let targetElement_tr = targetElement.parents('tr');
  let targetElement_tr = targetElement.closest('tr');

  let commentTrExisted = targetElement_tr.next("tr.commenttr");

  let commentTr = $('<tr class="commenttr"></tr>');
  if (isMultiComments || commentTrExisted.length == 0) {
    targetElement_tr.after(commentTr)
  } else {
    commentTr = commentTrExisted;
  }

  let preColspanSum_c = 0;
  commentTr.find('td').each(function () {
    preColspanSum_c += +$(this).attr('colspan');
  });

  let preColspanSum = 0;
  targetElement.closest('td').prevAll().each(function () {
    preColspanSum += +$(this).attr('colspan');
  });
  if (preColspanSum > 0) {
    if (preColspanSum > preColspanSum_c) {
      commentTr.append($('<td colspan="' + (preColspanSum - preColspanSum_c) + '" style="vertical-align:top;"></td'));
    }
  }

  let comment_td = $('<td colspan="' + commentColNum + '" style="vertical-align:top;"></td');
  commentTr.append(comment_td);
  let commentsElement = $('<div id="' + commentsId + '" class="ItemComments">' + comments + '</div>');
  comment_td.append(commentsElement);

  let paddingRight = parseInt(targetElement.closest('td').css("padding-right"));
  commentsElement.css({
    'position': 'relative',
    'left': targetElement.position().left,
    'top': -15,
    'width': targetElement_tr.width() * commentColNum / totalColNum - targetElement.position().left * 2 - paddingRight,
    'overflow-wrap': 'break-word'
  });
}

/* 不正項目の背景色変更 */
function addStyleToErrorItem() {
  if (typeof (Page_Validators) == 'undefined' || $('ul[role="presentation"] li a').length == 0) return;
  for (let i = 0; i < Page_Validators.length; i++) {
    $('#' + Page_Validators[i].controltovalidate).removeClass('ErrorItem');
    //$('#' + Page_Validators[i].controltovalidate).css('background-color', '!important');
  }
  $('ul[role="presentation"] li a').each(function () {
    let id = $(this).attr('referencecontrolid');
    $('#' + id).addClass('ErrorItem');
    //$('#' + id).css({'background-color': '#FDE9E9 !important'});
  });
  $('select option').css({ 'color': 'black', 'font-style': 'normal', 'background-color': 'white' });
}

/* フォームの項目を必須にする */
function addValidation(elementId, elementLabel) {
  removeValidation(elementId);
  var newValidator = document.createElement('span');
  newValidator.style.display = "none";
  newValidator.id = elementId + "add_validator";
  newValidator.controltovalidate = elementId;
  newValidator.errormessage = "<a href=\'#" + elementId + "_label\' onclick=\'javascript:scrollToAndFocus(\"" + elementId + "_label\",\"" + elementId + "\");return false;\' referenceControlId=" + elementId + ">" + elementLabel + " は必須フィールドです。</a>";
  newValidator.validationGroup = "";
  newValidator.initialvalue = "";
  newValidator.evaluationfunction = function () {
    var value = $("#" + this.controltovalidate).val();
    if (value == null || value == "") {
      return false;
    } else {
      return true;
    }
  };
  Page_Validators.push(newValidator);
  $("#" + elementId + "_label").parent().addClass("required");
}

/* フォームの項目を非必須にする  */
function removeValidation(elementId, validatorIdSuffix = 'add_validator') {
  if (typeof (Page_Validators) == 'undefined') return;
  let validatorIndex = -1;
  let validatorId = elementId + validatorIdSuffix;
  for (let i = 0; i < Page_Validators.length; i++) {
    if (Page_Validators[i].id == validatorId) {
      validatorIndex = i;
      break;
    }
  }
  if (validatorIndex >= 0) {
    Page_Validators.splice(validatorIndex, 1);
    $("#" + elementId + "_label").parent().removeClass("required");
  }
}

function addCustomValidation(elementId, efun, validatorIdSuffix, errMsg) {
  removeValidation(elementId, validatorIdSuffix);
  var newValidator = document.createElement('span');
  newValidator.style.display = "hidden";
  newValidator.id = elementId + validatorIdSuffix;
  newValidator.controltovalidate = elementId;
  newValidator.errormessage = "<a href=\'#" + elementId + "_label\' onclick=\'javascript:scrollToAndFocus(\"" + elementId + "_label\",\"" + elementId + "\");return false;\' referenceControlId=" + elementId + ">" + errMsg + "</a>";
  newValidator.validationGroup = "";
  newValidator.initialvalue = "";
  newValidator.evaluationfunction = efun;
  Page_Validators.push(newValidator);
}

function setMinNumOfDigits(eleId, numOfDigits, errMsg) {
  addCustomValidation(eleId, () => { let val = $('#' + eleId).val(); return val.length == 0 || val.length == numOfDigits }, 'add_digitsValidator', errMsg);
};


function saveToLocalStorage(key, value) {
  localStorage.setItem(key, JSON.stringify(value));
}

function getFromLocalStorage(key) {
  var item = localStorage.getItem(key);
  return item ? JSON.parse(item) : null;
}

function removeLocalStorage(key) {
  localStorage.removeItem('key');
}

//Web API ajax wrapper
(function (webapi, $) {
  function safeAjax(ajaxOptions) {
    var deferredAjax = $.Deferred();
    shell.getTokenDeferred().done(function (token) {
      // Add headers for ajax
      if (!ajaxOptions.headers) {
        $.extend(ajaxOptions, {
          headers: {
            "__RequestVerificationToken": token
          }
        });
      } else {
        ajaxOptions.headers["__RequestVerificationToken"] = token;
      }
      ajaxOptions.async = false;
      $.ajax(ajaxOptions)
        .done(function (data, textStatus, jqXHR) {
          validateLoginSession(data, textStatus, jqXHR, deferredAjax.resolve);
        }).fail(deferredAjax.reject); //ajax
    }).fail(function () {
      deferredAjax.rejectWith(this, arguments); // On token failure pass the token ajax and args
    });
    return deferredAjax.promise();
  }
  webapi.safeAjax = safeAjax;
})(window.webapi = window.webapi || {}, jQuery)

//Applicaton ajax wrapper 
function appAjax(processingMsg, ajaxOptions) {
  //notificationMsg.show(processingMsg);
  return webapi.safeAjax(ajaxOptions)
    .fail(function (response) {
      if (response.responseJSON) {
        saveToLocalStorage("seidoApiErrorRes", response); //.responseJSON.error);
        redirect('/systemerror/');
        // alert("Error: " + response.responseJSON.error.message)
      } else {
        //alert("Error: Web API is not available, Please refresh the screen and try again. ")
        alert("Error: Web API is not available... ")
      }
    })//.always(notificationMsg.hide);
}

//columnStr : fullname,firstname,lastname,emailaddress1,telephone1
//where: revenue gt 90000&
//orderby: name asc,revenue desc
function loadRecords(tblName, columnStr = '', where = '', orderBy = '') {
  let urlstr = "/_api/" + tblName + 's';
  if (columnStr.length > 0) urlstr = urlstr + "?$select=" + columnStr;
  if (where.length > 0) urlstr = urlstr + "&$filter=" + where;
  if (orderBy.length > 0) urlstr = urlstr + "&$orderby=" + orderBy;
  //urlstr = "/_api/" + tblName + '(6df2f2fd-3db0-ef11-95f6-000d3a527c3e)';
  //console.log(urlstr)
  return appAjax('Loading...', {
    type: "GET",
    //async: false,
    url: urlstr,
    contentType: "application/json"
  });
}

async function readRecords(tblName, columnStr = '', where = '', orderBy = '') {
  let d = [];
  await loadRecords(tblName
    , columnStr
    , where
    , orderBy
  ).done(function (data) {
    d = data.value;
  })
  return d;

}

// recordObj = {
//   firstname: "Willie",
//   lastname: "Huff" + _.random(100, 999),
//   emailaddress1: "Willie.Huff@contoso.com",
//   telephone1: "555-123-4567"
// };
async function insertRecord(tblName, recordObj) {
  let newUuid = '';
  await appAjax('Adding...', {
    type: "POST",
    url: "/_api/" + tblName + "s",
    contentType: "application/json",
    data: JSON.stringify(recordObj),
    success: function (res, status, xhr) {
      newUuid = xhr.getResponseHeader("entityid");
    }
  });
  return newUuid;
}

// recordObj = {
//   "value": "abc@mail.com",
// };
//レコード更新
async function updateRecord(tblName, recordId, updateObj) {
  let result = false;
  await appAjax('Updating...', {
    type: "PATCH",
    url: "/_api/" + tblName + "s(" + recordId + ")/",
    contentType: "application/json",
    data: JSON.stringify(updateObj),
    success: function (res) {
      result = true;
    }
  });
  return result;
}
/* updateObj={value:1} */
//特定のフィールド更新
async function updateField(tblName, recordId, fieldName, updateObj) {
  let result = false;
  await appAjax('Updating...', {
    type: "PUT",
    url: "/_api/" + tblName + "s(" + recordId + ")/" + fieldName,
    contentType: "application/json",
    data: JSON.stringify(updateObj),
    success: function (res) {
      result = true;
    }
  });
  return result;
}

async function deleteRecord(tblName, recordId) {
  let result = false;
  await appAjax('Deleting...', {
    type: "DELETE",
    url: "/_api/" + tblName + "s(" + recordId + ")",
    contentType: "application/json",
    success: function (res) {
      result = true;
    }
  });
  return result;
}

function redirect(url) {
  window.location.href = url;
}

function showConfirmDialog(title, message, yesAction = null, noAction = null, autoClose = true) {
  let dlgDiv = $(`<div id="dialog-confirm"> ${message} </div>`);
  dlgDiv.dialog({
    resizable: false,
    height: "auto",
    width: 400,
    title: title,
    modal: true,
    closeOnEscape: false,
    open: function () {
      $(this).parent().find("button:contains('はい')").blur();
      $(this).parent().find("button:contains('いいえ')").focus();
    },
    buttons: {
      "はい": function () {
        if (yesAction != null) yesAction();
        if (autoClose) $(this).dialog("close");
      },
      "いいえ": function () {
        if (noAction != null) noAction();
        if (autoClose) $(this).dialog("close");
      }
    }
  });
}

function showProcessingDialog(title, message) {
  // let dlgDiv = $(' \
  //           <div id="dialog-Processing"> \
  //               <p>' + message + '</p> \
  //           </div> \
  //        ');
  let dlgDiv = $(`<div id="dialog-Processing"> ${message} </div>`);
  dlgDiv.dialog({
    resizable: false,
    height: "auto",
    width: 400,
    title: title,
    modal: true,
    closeOnEscape: false,
    buttons: {}
  });
}

function showErrorDialog(title, message) {
  // let dlgDiv = $(' \
  //           <div id="dialog-error"> \
  //               <p>' + message + '</p> \
  //           </div> \
  //        ');
  let dlgDiv = $(`<div id="dialog-error"> ${message} </div>`);
  dlgDiv.dialog({
    resizable: false,
    height: "auto",
    width: 500,
    title: title,
    modal: true,
    closeOnEscape: false,
    buttons: {
      "はい": function () {
        $(this).dialog("close");
      }
    }
  });
}

/*複数行テキスト改行表示*/
function kaigyoHyoji(tr, tdAttributes) {
  var tdNum = 0;
  for (tdNum; tdNum < tdAttributes.length; tdNum++) {
    var tdAttributeName = 'td[data-attribute="' + tdAttributes[tdNum] + '"]';
    var textString = tr.find(tdAttributeName).attr('data-value');
    if (textString !== '' && textString !== undefined) {
      fukusugyoText = textString.split(/\r\n|\r|\n/);
      if (fukusugyoText.length > 1) {
        tr.find(tdAttributeName).text("");
        for (var i = 0; i < fukusugyoText.length; i++) {
          tr.find(tdAttributeName).append(fukusugyoText[i] + '</br>');
        }
      } else {
        tr.find(tdAttributeName).text(fukusugyoText);
      }
    }
  }
};

/*日付フォーマット("YYYY/MM/DD HH:MM")表示*/
function dateTimeFormart(dateTime) {
  var yearString = dateTime.getFullYear().toString();
  var month = dateTime.getMonth() + 1;
  var monthString = ("00" + month).slice(-2);
  var dayString = ("00" + dateTime.getDate()).slice(-2);
  var hourString = ("00" + dateTime.getHours()).slice(-2);
  var minuteString = ("00" + dateTime.getMinutes()).slice(-2);
  var dateTimeFormart = yearString + "/" + monthString + "/" + dayString + " " + hourString + ":" + minuteString
  return dateTimeFormart;
};

var helpUrl = {
  'url1': '/help#help1'         // 年齢基準（以上） 年齢基準（未満）
  ,'url2': '/help#help2'        // 助成対象範囲(2)複数選択フラグ
  ,'url3': '/help#help3'        // 助成方法
  ,'url4': '/help#help4'
  ,'url5': '/help#help5'
  ,'url6': '/help#help6'        // 入院月数条件開始月
  ,'url7': '/help#help7'
  ,'url8': '/help#help8'
  // ,'url9': '/help#help9'
  ,'url9': '/help#help8'        // 助成・自己負担範囲詳細（入院）助成・自己負担範囲詳細（外来）
  ,'url10': '/help#help10'      // 1日当たりの上限額
  ,'url11': '/help#help11'      // 助成有無
  ,'url12': '/help#help12'
  // ,'url13': '/help#help13'
  ,'url13': '/help#help12'
  ,'url14': '/help#help14'      // 公費適用優先順位

  ,'url15': '/help#help15'        // 事業名（正式名称）
  ,'url16': '/help#help16'        // 分類番号１
  ,'url17': '/help#help17'        // 公費負担者番号（８桁）
  ,'url18': '/help#help18'        // 助成内容有効開始年月日
  ,'url19': '/help#help19'        // 医科（入院）
  ,'url20': '/help#help20'        // 社保
  ,'url21': '/help#help21'        // ひとり親等医療費助成対象者識別フラグ
  ,'url22': '/help#help22'        // 所得区分
  ,'url23': '/help#help23'        // 高額かつ長期
  ,'url24': '/help#help24'        // 就学状況
  ,'url25': '/help#help25'        // 設定
  ,'url26': '/help#help26'        // 設定条件フラグ
  ,'url27': '/help#help27'        // 初診時のみ条件
  ,'url28': '/help#help28'        // 連続入院期間の条件
  ,'url29': '/help#help29'        // 複数回受診条件回数（以上）
  ,'url30': '/help#help30'        // 保険制度変更前の患者負担額の累計
  ,'url31': '/help#help31'        // 助成範囲（入院時食事療養費）
  ,'url32': '/help#help32'        // 助成範囲（入院時生活療養費）
  ,'url33': '/help#help33'        // 上限額識別フラグ
  ,'url34': '/help#help34'        // 端数条件（計算単位）
  ,'url35': '/help#help35'        // 上限額入院外来合算フラグ
  ,'url36': '/help#help36'        // 入院
  ,'url37': '/help#help37'        // 入院日数条件開始日
  ,'url38': '/help#help38'        // 1回当たりの上限額
  ,'url39': '/help#help39'        // 1日当たりの上限額の適用上限日数
  ,'url40': '/help#help40'        // 1日当たりの上限額
  ,'url41': '/help#help41'        // 1日当たりの上限額
  ,'url42': '/help#help42'        // 事業（1）
  ,'url43': '/help#help43'        // その他制度に係る参考情報（自治体内部向け）
}
